<?php
class UserMgmt
{
	private $_user_data_file;
	
	public function __construct()
	{
		$this->_user_data_file = $_SERVER['DOCUMENT_ROOT'] . '/vkapp/NavEditor2/data/users';
	}
	
	public function GetUsers()
	{
		if(!file_exists($this->_user_data_file)) {
			return NULL;
		}
		$jss = file_get_contents($this->_user_data_file);
		if($jss == '') {
			return NULL;
		} else {
			return $jss;
		}
	}
	
	public function AddUser($user_name, $passwd)
	{
		$jss = file_get_contents($this->_user_data_file);
		$users = json_decode($jss, TRUE);
		if(!is_null($users)) {
			foreach($users as $udata) {
				if(strcmp($udata['user_name'], $user_name) == 0) {
					return FALSE;
				}
			}
		}
		if(is_null($users)) {
			$users = array();
		}
		$pwd_hash = md5($passwd);
		array_push($users, array('user_name' => $user_name, 'password_hash' => $pwd_hash));
		$jss1 = json_encode($users);
		file_put_contents($this->_user_data_file, $jss1);
		return TRUE;
	}
	
	public function Login($user_name, $passwd)
	{
		$jss = file_get_contents($this->_user_data_file);
		if($jss == '') {
			return FALSE;
		} else {
			$users = json_decode($jss, TRUE);
			foreach($users as $udata) {
				if(strcmp($udata['user_name'], $user_name) == 0) {
					if(strcmp($udata['password_hash'], md5($passwd)) == 0) {
						return TRUE;
					} else {
						return FALSE;
					}
				}
			}
			return FALSE;
		}
	}
	
	public function UpdateUser($user_name, $new_pwd)
	{
		$jss = file_get_contents($this->_user_data_file);
		if($jss == '') {
			return FALSE;
		} else {
			$users = json_decode($jss, TRUE);
			for($i = 0; $i < count($users); $i++) {
				if(strcmp($users[$i]['user_name'], $user_name) == 0) {
					$users[$i]['password_hash'] = md5($new_pwd);
					break;
				}
			}
			$jss1 = json_encode($users);
			file_put_contents($this->_user_data_file, $jss1);
			return TRUE;
		}
	}
	
	public function RemoveUser($user_name)
	{
		$jss = file_get_contents($this->_user_data_file);
		if($jss == '') {
			return FALSE;
		} else {
			$users = json_decode($jss, TRUE);
			for($i = 0; $i < count($users); $i++) {
				if(strcmp($users[$i]['user_name'], $user_name) == 0) {
					array_splice($users, $i, 1);
					break;
				}
			}
			$jss1 = json_encode($users);
			file_put_contents($this->_user_data_file, $jss1);
			return TRUE;
		}
	}
}
?>
